/* A Bison parser, made by GNU Bison 2.0.  */

/* C++ Skeleton parser for LALR(1) parsing with Bison,
   Copyright (C) 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */
/* FIXME: This is wrong, we want computed header guards.
   I don't know why the macros are missing now. :( */
#ifndef PARSER_HEADER_H
# define PARSER_HEADER_H

#include <string>
#include <iostream>

/* Using locations.  */
#define YYLSP_NEEDED 0

namespace yy
{
  class position;
  class location;
}

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     AND = 258,
     CALL = 259,
     CONDITION = 260,
     ELSE = 261,
     ENDIF = 262,
     ENDLOOP = 263,
     ENDMETHOD = 264,
     FALSE = 265,
     IF = 266,
     INPUT = 267,
     LOOP = 268,
     METHOD = 269,
     NOT = 270,
     NUMERIC = 271,
     OR = 272,
     OUTPUT = 273,
     RETURN = 274,
     SET = 275,
     STRING = 276,
     TRUE = 277,
     WHEN = 278,
     WHILE = 279,
     CLOSEBRACKET = 280,
     CLOSEPAREN = 281,
     DIVIDE = 282,
     EQUAL = 283,
     EQUALEQUAL = 284,
     GREATEREQUAL = 285,
     GREATERTHAN = 286,
     LESSEQUAL = 287,
     LESSTHAN = 288,
     MEMBEROF = 289,
     MINUS = 290,
     MULT = 291,
     OPENBRACKET = 292,
     OPENPAREN = 293,
     PLUS = 294,
     CONDITIONCONST = 295,
     NUMBER = 296,
     ID = 297,
     STRINGCONST = 298,
     PRINT = 299
   };
#endif
#define AND 258
#define CALL 259
#define CONDITION 260
#define ELSE 261
#define ENDIF 262
#define ENDLOOP 263
#define ENDMETHOD 264
#define FALSE 265
#define IF 266
#define INPUT 267
#define LOOP 268
#define METHOD 269
#define NOT 270
#define NUMERIC 271
#define OR 272
#define OUTPUT 273
#define RETURN 274
#define SET 275
#define STRING 276
#define TRUE 277
#define WHEN 278
#define WHILE 279
#define CLOSEBRACKET 280
#define CLOSEPAREN 281
#define DIVIDE 282
#define EQUAL 283
#define EQUALEQUAL 284
#define GREATEREQUAL 285
#define GREATERTHAN 286
#define LESSEQUAL 287
#define LESSTHAN 288
#define MEMBEROF 289
#define MINUS 290
#define MULT 291
#define OPENBRACKET 292
#define OPENPAREN 293
#define PLUS 294
#define CONDITIONCONST 295
#define NUMBER 296
#define ID 297
#define STRINGCONST 298
#define PRINT 299




/* Copy the first part of user declarations.  */
#line 10 "k.y"

 #include "ICode.h"
 
 #include <iostream>
 #include <string>
 #include <map>
 extern std::map<std::string, double> variables;

 #include "ICode.h"


/* Line 406 of lalr1.cc.  */
#line 148 "parser.h"

#include "stack.hh"
#include "location.hh"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error message.  */
#ifndef YYERROR_VERBOSE
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 22 "k.y"
union YYSTYPE {
    double dval;
    // const char * sval;
    const std::string * sval;
};
/* Line 406 of lalr1.cc.  */
#line 171 "parser.h"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

/* Copy the second part of user declarations.  */
#line 29 "k.y"

 // Announce to Flex the prototype we want for lexing function, ...
 # define YY_DECL						 \
 int yylex(YYSTYPE* yylval)
 // ... and declare it for the parser's sake.
 YY_DECL;


/* Line 406 of lalr1.cc.  */
#line 188 "parser.h"
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
do {							\
  if (N)						\
    {							\
      (Current).begin = (Rhs)[1].begin;			\
      (Current).end   = (Rhs)[N].end;			\
    }							\
  else							\
    {							\
      (Current).begin = (Current).end = (Rhs)[0].end;	\
    }							\
} while (0)
#endif

namespace yy
{
  class parser;

  template <typename P>
  struct traits
  {
  };

  template <>
  struct traits<parser>
  {
    typedef unsigned char token_number_type;
    typedef signed char       rhs_number_type;
    typedef int state_type;
    typedef YYSTYPE semantic_type;
    typedef location location_type;
  };
}

namespace yy
{
  /// A Bison parser.
  class parser
  {
    /// Symbol semantic values.
    typedef traits<parser>::semantic_type semantic_type;
    /// Symbol locations.
    typedef traits<parser>::location_type location_type;

  public:
    /// Build a parser object.
    parser () :
      yydebug_ (false),
      yycdebug_ (&std::cerr)
    {
    }

    virtual ~parser ()
    {
    }

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

    /// The current debugging stream.
    std::ostream& debug_stream () const;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);

  private:

    /// Call the scanner.
    virtual void yylex_ ();

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Generate an error message, and invoke error.
    virtual void yyreport_syntax_error_ ();

#if YYDEBUG
    /// \brief Report a symbol on the debug stream.
    /// \param yytype       The token type.
    /// \param yyvaluep     Its semantic value.
    /// \param yylocationp  Its location.
    virtual void yysymprint_ (int yytype,
			      const semantic_type* yyvaluep,
			      const location_type* yylocationp);
#endif /* ! YYDEBUG */


    /// State numbers.
    typedef traits<parser>::state_type state_type;
    /// State stack type.
    typedef stack<state_type>    state_stack_type;
    /// Semantic value stack type.
    typedef stack<semantic_type> semantic_stack_type;
    /// location stack type.
    typedef stack<location_type> location_stack_type;

    /// The state stack.
    state_stack_type yystate_stack_;
    /// The semantic value stack.
    semantic_stack_type yysemantic_stack_;
    /// The location stack.
    location_stack_type yylocation_stack_;

    /// Internal symbol numbers.
    typedef traits<parser>::token_number_type token_number_type;
    /* Tables.  */
    /// For a state, the index in \a yytable_ of its portion.
    static const signed char yypact_[];
    static const signed char yypact_ninf_;

    /// For a state, default rule to reduce.
    /// Unless\a  yytable_ specifies something else to do.
    /// Zero means the default is an error.
    static const unsigned char yydefact_[];

    static const signed char yypgoto_[];
    static const signed char yydefgoto_[];

    /// What to do in a state.
    /// \a yytable_[yypact_[s]]: what to do in state \a s.
    /// - if positive, shift that token.
    /// - if negative, reduce the rule which number is the opposite.
    /// - if zero, do what YYDEFACT says.
    static const unsigned char yytable_[];
    static const signed char yytable_ninf_;

    static const signed char yycheck_[];

    /// For a state, its accessing symbol.
    static const unsigned char yystos_[];

    /// For a rule, its LHS.
    static const unsigned char yyr1_[];
    /// For a rule, its RHS length.
    static const unsigned char yyr2_[];

#if YYDEBUG || YYERROR_VERBOSE
    /// For a symbol, its name in clear.
    static const char* const yyname_[];
#endif

#if YYDEBUG
    /// A type to store symbol numbers and -1.
    typedef traits<parser>::rhs_number_type rhs_number_type;
    /// A `-1'-separated list of the rules' RHS.
    static const rhs_number_type yyrhs_[];
    /// For each rule, the index of the first RHS symbol in \a yyrhs_.
    static const unsigned char yyprhs_[];
    /// For each rule, its source line number.
    static const unsigned char yyrline_[];
    /// For each scanner token number, its symbol number.
    static const unsigned short int yytoken_number_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yyreduce_print_ (int r);
    /// Print the state stack on the debug stream.
    virtual void yystack_print_ ();
#endif

    /// Convert a scanner token number to a symbol number.
    inline token_number_type yytranslate_ (int token);

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg        Why this token is reclaimed.
    /// \param yytype       The symbol type.
    /// \param yyvaluep     Its semantic value.
    /// \param yylocationp  Its location.
    inline void yydestruct_ (const char* yymsg,
                             int yytype,
                             semantic_type* yyvaluep,
                             location_type* yylocationp);

    /// Pop \a n symbols the three stacks.
    inline void yypop_ (unsigned int n = 1);

    /* Constants.  */
    static const int yyeof_;
    /* LAST_ -- Last index in TABLE_.  */
    static const int yylast_;
    static const int yynnts_;
    static const int yyempty_;
    static const int yyfinal_;
    static const int yyterror_;
    static const int yyerrcode_;
    static const int yyntokens_;
    static const unsigned int yyuser_token_number_max_;
    static const token_number_type yyundef_token_;

    /* State.  */
    int yyn_;
    int yylen_;
    int yystate_;

    /* Error handling. */
    int yynerrs_;
    int yyerrstatus_;

    /* Debugging.  */
    int yydebug_;
    std::ostream* yycdebug_;

    /* Look-ahead and look-ahead in internal form.  */
    int yylooka_;
    int yyilooka_;

    /// Semantic value of the look-ahead.
    semantic_type yylval;
    /// Location of the look-ahead.
    location_type yylloc;
    /// The locations where the error started and ended.
    location yyerror_range_[2];

    /// $$.
    semantic_type yyval;
    /// @$.
    location_type yyloc;

  };
}

#endif /* ! defined PARSER_HEADER_H */
